/* eslint-disable */
const fs = require('fs-extra')
var path = require('path')
var glob = require('glob')
const cheerio = require('cheerio')
const chalk = require('chalk')
var minify = require('html-minifier').minify
const { version } = require('../package.json')
var UglifyJS = require('uglify-js')
const { time } = require('console')
// let this.conf.distPath =''// 项目目录  path.join(__dirname,'../../build')
var conf = {
  show: false,
  floderName: 'HDC'
}

let jsStr = null
let log_ = chalk.blueBright('\nHtml-disable-cache:\n    ')
let times = 10001
/**
 * distPath 是静态文件html文件夹的路径
 * config{
 * floderName 放js的文件夹
 * injectCode:要注入的代码
 * {
     position:'',
     tyle:'',
     code:''
    }
 * }
 * */
function HDC(distResolvePath, config = {}) {
  let initConf = {
    htmlNum: 0,
    staticNum: 0,
    didHtml: [],
    notDidHtml: ['']
  }
  this.conf = {
    injectHDC: true, // 是否注入hdc代码到html文件中
    useFileType: 2, //1 最新的 2 原有
    show: false,
    distPath: '',
    floderName: 'HDC',
    removeIgnoreAttr: true,
    ignoreAttr: 'hdc-ignore', // 排除处理的js或者css
    doStyle: false,
    injectCode: [],
    loadType: null,
    expire: null,
    url: null,
    loadModeIsSave: null,
    checkUpdateDelay: 1000, // 延迟检测更新的时间默认1s
    entryFileLoadErrorInfo: null,
    entryFileLoadErrorCallScript: null,
    renderErrorInfoElement: 'body' //显示错误信息的dom元素
  }
  if (typeof distResolvePath === 'string') {
    this.conf.distPath = distResolvePath
  } else if (typeof distResolvePath === 'object') {
    Object.assign(this.conf, distResolvePath, initConf)
  }
  if (config.injectCode && !Array.isArray(config.injectCode)) {
    config.injectCode = [config.injectCode]
  }
  Object.assign(this.conf, config, initConf)
  // 判断一些预设量
  // 延迟检测更新的时间
  let insertStr = `window.HDCCHECKUPDATEDELAY=${this.conf.checkUpdateDelay};`
  if (this.conf.loadType !== null) {
    insertStr += `window.HDCCONFLOADTYPE=${this.conf.loadType};`
  }
  if (this.conf.expire !== null) {
    insertStr += `window.HDCCONFEXPIRE='${this.conf.expire}';`
  }
  if (this.conf.loadModeIsSave !== null) {
    insertStr += `window.HDCCONFISONLYLOAD=${this.conf.loadModeIsSave};`
  }
  if (this.conf.url !== null) {
    insertStr += `window.HDCCONFURL='${this.conf.url}';`
  }
  if (this.conf.entryFileLoadErrorInfo !== null) {
    insertStr += `window.HDCENTRYFILELOADERRORINFO='${this.conf.entryFileLoadErrorInfo
      ?.replace(/'/g, "\\'")
      .replace(/\n/g, '')}';window.HDCRENDERERRORINFOELEMENT='${this.conf.renderErrorInfoElement}';`
  }
  if (this.conf.entryFileLoadErrorCallScript) {
    insertStr += `window.HDCENTRYFILELOADERRORCALLSCRIPT='${
      UglifyJS.minify(this.conf.entryFileLoadErrorCallScript).code || this.conf.entryFileLoadErrorCallScript
    }';`
  }
  let useFileTypeArray = ['', 'loadJsTem1.js', 'loadJsTem2.js', 'loadJsTem3.js']
  jsStr = fs.readFileSync(path.resolve(__dirname, useFileTypeArray[this.conf.useFileType]), 'utf8')
  jsStr = jsStr.replace('__hdc__version__', version)
  // this.hdcsrc = path.join(this.conf.distPath, this.conf.floderName, `hdc.${ version }.min.js`)
  // 优化版本升级导致的误差
  this.hdcsrc = path.join(this.conf.distPath, this.conf.floderName, `hdc.min.js`)
  // 0.6.0 修改为所有的都都输出到文件里
  // if (+this.conf.useFileType === 3) {
  // 支持设置公共的url  只是针对useFileType=3
  if (this.conf.hdcUrl) {
    this.hdcsrc = this.conf.hdcUrl
  } else {
    this.conf.staticNum += 1

    // console.log(insertStr)
    writJs.call(this, this.hdcsrc, UglifyJS.minify(insertStr + jsStr).code)
  }
  // }
  times = this.conf.loadType === 1 || this.conf.loadType === null ? times : Date.now()
  if (!fs.pathExistsSync(this.conf.distPath)) {
    console.log(log_, chalk.yellow('需要保证 ' + this.conf.distPath + '目录存在'))
    process.exit(0)
  }
  console.log(log_, chalk.yellow('HDC处理的目录是 ' + this.conf.distPath))
  var cache_html = getMultiEntry(this.conf.distPath + '/**/**/*.html') // 获得入口js文件
  this.conf.htmlNum = Object.keys(cache_html).length
  this.conf.staticNum += this.conf.htmlNum
  disCache.call(this, cache_html)
}
//---------some fn
function disCache(obj) {
  var j = 0
  for (let i in obj) {
    j++
    var html = fs.readFileSync(obj[i], 'utf8')
    doHtml.call(this, html, obj[i], i, j)
  }
  if (!j) {
    console.log(log_, chalk.yellow('没有要处理的HTML文件,请确定路径输入正确'))
    process.exit(0)
  }
}
//-------- 处理html文件
function doHtml(html, htmlUrl, baseName, htmlIndex) {
  let $ = cheerio.load(html) // 加载一个 html 文本
  if ($('[hdc-did]').length) {
    console.log(log_, chalk.cyanBright(htmlUrl + ':该文件已经被HDC处理了,若要更新请手动更新该文件加载的js中的参数'))
    return false
  }
  let scripts = $(`script[src]:not([${this.conf.ignoreAttr}])`)
  let scriptsSrc = []
  let needLoadJs = []
  // 处理css
  if (this.conf.doStyle) {
    //处理 style
    let styls = $(`link[href][rel = "stylesheet"]:not([${this.conf.ignoreAttr}])`)
    styls.each(function (i, v) {
      scriptsSrc.push(v.attribs.href)
      needLoadJs.push({
        url: v.attribs.href,
        type: 'css',
        position: 'head',
        id: ''
      })
    })
    styls.remove()
  }
  // 处理js
  scripts.each(function (i, v) {
    let position = 'head'
    let id = ''
    let isModule = v.attribs.type === 'module'
    let isNoModule = v.attribs.nomodule === '' && v.attribs.nomodule !== undefined
    if (v.parent.name == 'head') {
      position = 'head'
    } else if (v.parent.name == 'body') {
      position = 'body'
    } else if (v.parent.attribs.id) {
      position = ''
      id = v.parent.attribs.id
    } else {
      position = 'body'
    }
    scriptsSrc.push(v.attribs.src)
    needLoadJs.push({
      url: v.attribs.src,
      type: 'js',
      position,
      id,
      moduleType: isModule ? 1 : isNoModule ? 2 : 0 // 0module 1 nomodule 2 normal
    })
  })
  scripts.remove()

  if (this.conf.removeIgnoreAttr) {
    $(`script[${this.conf.ignoreAttr}]`).removeAttr(this.conf.ignoreAttr)
    $(`link[rel = "stylesheet"][${this.conf.ignoreAttr}]`).removeAttr(this.conf.ignoreAttr)
    // $(`script[${ this.conf.ignoreAttr }]`,`link[rel = "stylesheet"][${ this.conf.ignoreAttr }]`).removeAttr(this.conf.ignoreAttr)
  }
  let baseNameUrl = path.normalize(baseName, '/').replace(this.conf.distPath, '').split(path.sep).join('_')
  if (baseNameUrl[0] != '_') {
    baseNameUrl = '_' + baseNameUrl
  }
  let jsName = './' + this.conf.floderName + '/' + baseNameUrl + '.js'
  // jsName=path.relative(path.normalize(baseName,'../'),path.join(distPath,jsName))
  if (needLoadJs.length) {
    this.conf.didHtml.push(htmlUrl)
    injectCode($, this.conf.injectCode)
    // 增加 esmodule 支持
    var sciprtMs = $('body script')
    var hasIos10 = false
    sciprtMs.each((i, v) => {
      if (v.children[0] && v.children[0].data.indexOf('"noModule"') > -1) {
        // 需要替换
        $(v).remove()
        hasIos10 = true
        $('body').append(`
  <script  hdc-did>
    !(function () {
      var e = document,
        t = e.createElement('script')
      if (!('noModule' in t) && 'onbeforeload' in t) {
        var n = !1
        e.addEventListener(
          'beforeload',
          function (e) {
            if (e.target === t) {
              n = !0
              window.__browserSupportModulesIOS = true
            } else if (!e.target.hasAttribute('nomodule') || !n) {
              return
            }
            e.preventDefault()
          },
          !0
        ),
          (t.type='module'),
          (t.src = '.'),
          e.head.appendChild(t),
          t.remove()
      }
    })();</script>
      `)
      }
      // console.log('sciprtMs', v, i)
    })
    // console.log($('body script')[sciprtMs.length - 1])

    $('body').append(`
      <script nomodule hdc-did> !(function () {
        var t = document.createElement('script')
        if (!('noModule' in t) && 'onbeforeload' in t ${hasIos10 ? '&&!window.__browserSupportModulesIOS' : ''}) {
          window.__browserHasNotModules = !0
        }
      })();</script> ${
        /*+this.conf.useFileType === 3 ?*/
        `<script type='text/javascript' charset="utf-8" language='javascript' src='${
          this.hdcsrc.indexOf('http') === 0
            ? this.hdcsrc
            : path.relative(path.join(baseName, '../'), this.hdcsrc).split(path.sep).join('/')
        }' hdc='${path
          .relative(path.join(baseName, '../'), path.join(this.conf.distPath, jsName))
          .split(path.sep)
          .join('/')}' hdc-did></script>`
        /*: `
  <script type='text/javascript' charset="utf-8" language='javascript' hdc-did>
    ${ jsStr.replace(
            'replaceUrl',
            path
              .relative(
                path.join(baseName, '../'),
                path.join(this.conf.distPath, jsName)
              )
              .split(path.sep)
              .join('/')
          )
        }
    </script>`
    */
      }
`)
    //.replace('//loadErrorList', `(window['__hdc__loadFn'] || window['__loadFn'])(${ JSON.stringify(needLoadJs) }, ${ times })`)
    // 支持有preload
    if (this.conf.loadType === 2) {
      $('[rel="preload"]').each((obj, elm) => {
        if (scriptsSrc.indexOf(elm.attribs.href) > -1) {
          elm.attribs.href = elm.attribs.href + '?HDC=' + times
        }
      })
      $('[rel="modulepreload"]').each((obj, elm) => {
        if (scriptsSrc.indexOf(elm.attribs.href) > -1) {
          elm.attribs.href = elm.attribs.href + '?HDC=' + times
        }
      })
    }
    let htmlData = minify($.html(), {
      removeComments: true,
      collapseWhitespace: true,
      minifyJS: true,
      minifyCSS: true
    })
    writeHtml.call(this, htmlUrl, htmlData)
    let jsData = '(window["__hdc__loadFn"]||window["__loadFn"])(' + JSON.stringify(needLoadJs) + ',' + +times + ');'
    writJs.call(this, path.join(this.conf.distPath, jsName), jsData)
  } else {
    this.conf.notDidHtml.push(htmlUrl)
    if (htmlIndex + 1 == this.conf.htmlNum) {
      console.log(
        log_,
        chalk.cyanBright(
          `该文件夹下的HTML文件没有做处理${this.conf.notDidHtml?.join(
            '\n      '
          )}\n \n      可能原因是：\n     1、没有引入外部JS、css \n     2、已经做过处理`
        )
      )
    }
  }
}
function injectCode($, code) {
  if (!code) return
  code.forEach(v => {
    if (typeof v === 'string') {
      $('body').append(`
  <script type='text/javascript' language='javascript' hdc-did>
    ${v}
    </script>
  `)
    } else if (typeof v === 'object') {
      $(v.position || 'body').append(`
${
  v.type === 'style'
    ? '<style  hdc-did>'
    : v.type === 'script'
    ? "<script type='text/javascript' language='javascript' hdc-did>"
    : ''
}
${v.code}
${v.type === 'style' ? '</style>' : v.type === 'script' ? '</script>' : ''}
`)
    }
  })
}
function writJs(jsPath, data) {
  fs.exists(path.dirname(jsPath), exists => {
    if (exists) {
      _wJs.call(this, jsPath, data)
    } else {
      mkDirSync(this.conf.distPath, path.relative(this.conf.distPath, path.dirname(jsPath)))
      _wJs.call(this, jsPath, data)
    }
  })
}
function _wJs(jsPath, data) {
  fs.writeFile(jsPath, data, err => {
    if (err) throw err
    if (this.conf.show) {
      console.log(log_, chalk.green(jsPath + '文件已建立'))
    }
    this.conf.staticNum--
    if (this.conf.staticNum === 0) {
      console.log()
      console.log(log_, chalk.green(' js文件已建立'))
      if (this.conf.htmlNum === 0) {
        overOp.call(this)
      }
    }
  })
}
function writeHtml(filePath, data) {
  if (!this.conf.injectHDC) {
    return false
  }
  fs.writeFile(filePath, data, err => {
    if (err) throw err
    if (this.conf.show) {
      console.log(log_, chalk.green(filePath + '文件处理完毕'))
    }
    this.conf.htmlNum--
    if (this.conf.htmlNum === 0) {
      console.log()
      console.log(log_, chalk.green(' html文件处理完毕'))

      if (this.conf.staticNum === 0) {
        overOp.call(this)
      }
    }
  })
}
function overOp() {
  this.conf.finish && this.conf.finish()
}
function mkDirSync(basePath, newPath) {
  let pathArr = newPath.split(path.sep)
  let newPathUrl = basePath
  // console.log(pathArr,newPathUrl)
  pathArr.forEach(res => {
    newPathUrl = path.join(newPathUrl, res)
    if (!fs.existsSync(newPathUrl)) {
      fs.mkdirSync(newPathUrl)
    }
  })
}
function getMultiEntry(globPath) {
  var entries = {}
  let basename
  let tmp
  let pathname
  // console.log('globPath', globPath)
  glob.sync(globPath).forEach(function (entry) {
    basename = path.basename(entry, path.extname(entry))
    // console.log(entry, basename)
    // tmp = entry.split('/').splice(-4)
    // 优化 多层级页面 路径获取错误
    tmp = entry.split('/')
    var stat = fs.lstatSync(entry)
    if (!stat.isDirectory()) {
      // true || false 判断是不是文件夹
      tmp.splice(tmp.length - 1)
      // console.log(entry, tmp)
      var pathsrc = tmp.join('/')
      if (tmp[0] == 'src') {
        tmp.shift()
        pathsrc = tmp.join('/')
      }
      // 优化 完毕
      // console.log(pathsrc)
      pathname = pathsrc + '/' + basename // 正确输出js和html的路径
      entries[pathname] = entry
      // console.log(pathname + '-----------' + entry)
    }
  })
  return entries
}
// 处理js
function getUgJs(str) {
  return str
    .replace(/function /g, '__FUN__')
    .replace(/var /g, '__VAR__')
    .replace(/let /g, '__LET__')
    .replace(/const /g, '__CONST__')
    .replace(/else if/g, '__ELSEIF__')
    .replace(/typeof /g, '__TYPEOF__')
    .replace(/\n/g, ';')
    .replace(/ /g, '')
    .replace(/{;/g, '{')
    .replace(/;}/g, '}')
    .replace(/__FUN__/g, 'function ')
    .replace(/__VAR__/g, 'var ')
    .replace(/__LET__/g, 'let ')
    .replace(/__CONST__/g, 'const ')
    .replace(/__ELSEIF__/g, 'else if')
    .replace(/__TYPEOF__/g, 'typeof ')
  //恢复 特殊字符
}
module.exports = function (...arry) {
  try {
    new HDC(...arry)
  } catch (e) {
    console.log(e)
  }
}
